function out=fit_exp1(lif, time, energy)

    data = [time' lif'./energy'];

% We want to fit exponential decay only to the part of the data, 
% where the laser is mostly over. 
% This code finds the position where the signal was maximal and
% then if fell to its third.
    [kolik, where] = max(data(:,2));
    hodnota = kolik;
    while (hodnota > kolik./3) &&  (where < length(data)),
    	where = where + 1;
    	hodnota = data(where, 2);
    end
    datafit = data(where:end, :);

% Fitting procedure: 
    tau = 2;
    tau=fminsearch(@(tau) expon1(tau,datafit),tau);
    [S,P,y]=expon1(tau, datafit);
    fit = y;

% Making the graph:
    ff = figure;
    plot(data(:,1), data(:,2), 'p', datafit(:,1), y, 'linewidth', 1.5); drawnow;
    velikostpisma=14;
    set(gca,'FontSize',velikostpisma)
    xlabel('time [ns]');
    ylabel('signal [arb. u.]');
    legend('measurement', ['fit:  \tau = ' num2str(tau) ' ns']);

% Save all important things in variable "out", which is the function output:
    out.tau = tau;
    out.fit = fit;
    out.data = data;
    out.squares = S;
    out.amplitude = P;

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [S, P1, y]=expon1(tau1, mereni)
x = mereni(:,1);

sumexp = sum( exp(-x./tau1).^2);
sumexpmeas = sum(exp(-x./tau1) .* mereni(:,2));
sumjmenovatel = sum( exp(-x./tau1));
P1 = sumexpmeas ./ sumexp;

y = P1 .* exp(-x./tau1);
S = sum((mereni(:,2)-y).^2);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
