function out = load_measurement(filename, rozsahr, rozsahsl, sl);

	jma=[sl filename '.SPE'];
	jmd=[sl filename '_dark.SPE']; jme=[sl filename '.txt'];

% Load main SPE file and its darkframe:
	Aall=loadSPE(jma,rozsahr,rozsahsl);
	[a,b,c]=size(Aall);
	D=loadSPE(jmd,rozsahr,rozsahsl);
	[da,db,dc]=size(D);
	D2=zeros(da,db);
	for j=1:dc,
		 D2=D2+D(:,:,j)/dc;
	end
	for jj=1:c,
		Aall(:,:,jj)=Aall(:,:,jj)-D2;
	end

% Load measurement of energy of laser pulses:
	EL=ctiEL_pokus(jme);
	[n,acc,rot]=hlavickaSPE(jma);
	if n~=c
		 error('n is not equal to c');
	end
	[M,S]=rozdel_energie(EL,n,acc,1,rot);


% Load information about timing:
	try
		pdw = ctiSPE_float([sl filename '_PDW.SPE']);
		time = pdw(1,:).*1e6; % ns
	catch
		disp('Warning: I do not have PDW file!')
		time = 1:c;
	end

% Save all important things in variable "out", which is the function output:
	out.data = Aall;
	out.time = time;
	out.energy = M;
	out.average(1, :) = mean(mean(out.data, 1), 2);

% Make graph of selected pixel area of the frame with the highest intensity:
	[nothing maximum_time] = max(out.average);
	figure; imagesc(out.data(:,:,maximum_time)); 
	colorbar; title(['picture ' num2str(maximum_time)]);

end

